'use strict';

exports.__esModule = true;
exports['default'] = posthtml;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _html2bemjson = require('html2bemjson');

var _html2bemjson2 = _interopRequireDefault(_html2bemjson);

var tmpl = new (require('bh').BH)();

var Posthtml = function Posthtml(options) {
    _classCallCheck(this, Posthtml);

    var opt = options || {};
    var _opt = opt;
    var tmplOptions = _opt.tmplOptions;
    var plugins = [];

    /**
     * Get options
     * @return {Object} options or {}
     */
    this.getOptions = function () {
        return opt;
    };

    /**
     * Parse html to json tree
     * @param  {String} html htmltree
     * @return {String} json jsontree
     */
    this.parse = function (html) {
        return [_html2bemjson2['default'].convert(html)];
    };

    /**
     * use plagins
     * @param  {function} plugin posthtml().use(plugin());
     */
    this.use = function (plugin) {
        plugins.push(plugin);
        return this;
    };

    /**
     * @param  {String} html htmltree
     * @return {[type]}      [description]
     */
    this.process = function (html) {

        var _this = this;

        tmplOptions && tmpl.setOptions(tmplOptions);

        return new Promise(function (resolve) {

            var tree = _this.parse(html);

            plugins.forEach(function (plugin) {
                tree = plugin(tree);
            });

            var json = tmpl.processBemJson(tree);

            resolve(tmpl.apply(json));
        });
    };
};

function posthtml(options) {
    return new Posthtml(options);
}

;
module.exports = exports['default'];